import logging
import os
import subprocess  # nosec

import torch
from pytorch_lightning import Trainer

from model import ClassifModel

ckpt_path = os.environ.get('CKPT', '/app/checkpoint')


def launch_tensorboard():
    ps = subprocess.Popen(['tensorboard', '--bind_all', '--logdir', ckpt_path])  # nosec
    return ps


if __name__ == '__main__':
    n_gpus = torch.cuda.device_count()
    logging.info(f'Using {n_gpus} gpus')
    trainer = Trainer(default_root_dir=ckpt_path, max_epochs=200)
    model = ClassifModel()
    ps = launch_tensorboard()
    trainer.fit(model)
    trainer.test(model)
